/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "nextStep.h"

extern int iCurrentValue;
int debug_level = 0;
int iNextStep = 0;

/** Initializes the nextStep module */
void
init_nextStep(void)
{
    const oid nextStep_oid[] = { 1,3,6,1,4,1,9876,11,7 };

  DEBUGMSGTL(("nextStep", "Initializing\n"));

    netsnmp_register_scalar(
        netsnmp_create_handler_registration("nextStep", handle_nextStep,
                               nextStep_oid, OID_LENGTH(nextStep_oid),
                               HANDLER_CAN_RWRITE
        ));
}

int
handle_nextStep(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    int ret;
    /* We are never called for a GETNEXT if it's registered as a
       "instance", as it's "magically" handled for us.  */

    /* a instance handler also only hands us one request at a time, so
       we don't need to loop over a list of requests; we'll only get one. */
    
    switch(reqinfo->mode) {

        case MODE_GET:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_GET\n" );
//            iNextStep++;
            snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                 &iNextStep               /* XXX: a pointer to the scalar's data */,
                 sizeof( iNextStep )      /* XXX: the length of the data in bytes */);
            break;

        /*
         * SET REQUEST
         *
         * multiple states in the transaction.  See:
         * http://www.net-snmp.org/tutorial-5/toolkit/mib_module/set-actions.jpg
         */
        case MODE_SET_RESERVE1:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_SET_RESERVE1\n" );
                /* or you could use netsnmp_check_vb_type_and_size instead */
            ret = netsnmp_check_vb_type(requests->requestvb, ASN_INTEGER);
            if ( ret != SNMP_ERR_NOERROR ) {
                snmp_log( LOG_ERR, "MODE_SET_RESERVE1 rc=%d\n", ret );
                netsnmp_set_request_error(reqinfo, requests, ret );
            }
            netsnmp_set_request_error( reqinfo, requests, SNMP_ERR_NOERROR );
            break;

        case MODE_SET_RESERVE2:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_SET_RESERVE2\n" );
            /* XXX malloc "undo" storage buffer */
//            if (/* XXX if malloc, or whatever, failed: */) {
//                netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_RESOURCEUNAVAILABLE);
//            }
            netsnmp_set_request_error( reqinfo, requests, SNMP_ERR_NOERROR );
            break;

        case MODE_SET_FREE:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_SET_FREE\n" );
            /* XXX: free resources allocated in RESERVE1 and/or
               RESERVE2.  Something failed somewhere, and the states
               below won't be called. */
            break;

        case MODE_SET_ACTION:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_SET_ACTION\n" );
            /* XXX: perform the value change here */
            { netsnmp_variable_list *var = requests->requestvb;
              netsnmp_vardata val = var->val;
              iNextStep = *val.integer;
              iCurrentValue += iNextStep;
            }
//            if (/* XXX: error? */) {
//                netsnmp_set_request_error(reqinfo, requests, /* some error */);
//            }
            break;

        case MODE_SET_COMMIT:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_SET_COMMIT\n" );
            /* XXX: delete temporary storage */
//            if (/* XXX: error? */) {
                /* try _really_really_ hard to never get to this point */
//                netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_COMMITFAILED);
//            }
            break;

        case MODE_SET_UNDO:
            if( debug_level ) snmp_log( LOG_INFO, "MODE_SET_UNDO\n" );
            /* XXX: UNDO and return to previous value for the object */
//            if (/* XXX: error? */) {
                /* try _really_really_ hard to never get to this point */
//                netsnmp_set_request_error(reqinfo, requests, SNMP_ERR_UNDOFAILED);
//            }
            break;

        default:
            /* we should never get here, so this is a really bad error */
            snmp_log(LOG_ERR, "unknown mode (%d) in handle_nextStep\n", reqinfo->mode );
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
