#include "common.h"

#define OID_MAX_LEN 120 
static char host[ 80 ], OID_current_value[ OID_MAX_LEN + 1 ], OID_next_step[ OID_MAX_LEN +1 ]; 

static int snmp_cmd( char *cmd, char* res, int len ) {
   FILE* f = popen( cmd, "r" );
   if( NULL == f ) return errno;
   fgets( res, len, f );
   if( rindex( res, '\n' ) != NULL ) *( rindex( res, '\n' ) ) = 0;
   return pclose( f );
}

void init_manager( int argc, int optind, char** argv ) {
   if( argc != optind + 1 ) {
      fprintf( stdout, "должен быть 1 параметр: IP/хост\n" );
      exit( EXIT_FAILURE );
   }
   strncpy( host, argv[ optind ], sizeof( host ) - 1 );
   if( snmp_cmd( "snmptranslate -On OLEJ-MANAGEMENT-MIB::currentValue",
                 OID_current_value, OID_MAX_LEN ) != 0 ) {
      fprintf( stdout, "не определён OID currentValue\n" );
      exit( EXIT_FAILURE );
   }
   if( snmp_cmd( "snmptranslate -On OLEJ-MANAGEMENT-MIB::nextStep",
                 OID_next_step, OID_MAX_LEN ) != 0 ) {
      fprintf( stdout, "не определён OID nextStep\n" );
      exit( EXIT_FAILURE );
   }
   if( debug_level )
      fprintf( stdout, "host: %s, currentValue OID=%s, nextStep OID=%s\n",
               host, OID_current_value, OID_next_step );
};

#define REP_MAX_LEN 400 
int get_value( void ) {
   int res = -1;
   char cmd[ REP_MAX_LEN + 1 ], rep[ REP_MAX_LEN + 1 ];
   sprintf( cmd, "snmpget -v2c -c public %s %s.0", host, OID_current_value );
   snmp_cmd( cmd, rep, REP_MAX_LEN ); 
   if( debug_level ) fprintf( stdout, "%s\n", rep );
   res = atoi( rindex( rep, ' ' ) );
   return res;
}

void do_step( int step ) {
   int res = -1;
   char cmd[ REP_MAX_LEN + 1 ], rep[ REP_MAX_LEN + 1 ];
   sprintf( cmd, "snmpset -v2c -c private %s %s.0 i %d", host, OID_next_step, step );
   snmp_cmd( cmd, rep, REP_MAX_LEN ); 
   if( debug_level ) fprintf( stdout, "%s\n", rep );
}
